; SBAS_PROCS_OUTLN - SBASIC OUTLN  V2.00  Stolen from PTR Toolkit
; V1.00, pjw, 2019 Aug 02, Patched and repackaged

	section code

	xdef	outln

	xref	chan_d6
	xref	getpars

	include 'dev8_keys_qdos_io'
	include 'dev8_keys_qlv'
	include 'dev8_keys_sbasic'
	include 'dev8_keys_err'

;+++
; OUTLN(#ch,) xs, ys, xo, yo (, xsh, ysh) (, mv)
;---
outln
	moveq	#0,d6			; outline channel 0

	lea.l	8(a3),a4
	cmp.l	a4,a5			; more than one parameters?
	bhi.s	beo_parm		;  yes

	bsr	chan_d6 		; see if we have a channel #0

cont
	bne.s	rts

	move.l	sb_buffb(a6),a1 	; -1 size (is this an outln default?)
	moveq	#-1,d0
	move.l	d0,(a6,a1.l)
	moveq	#0,d1
	moveq	#0,d2
	jmp	beo_doit

beo_parm
	bsr	chan_d6 		; get channel ID to outline
	bne.s	rts

	bsr	getpars 		;d0 = 0 => get any number of ints
	bne.s	beo_exit
*
*	See which options are in use
*
	moveq	#0,d1			; assume no shadow
	moveq	#0,d2			; and set outline

	lea	8(a1),a2		; point to extra parameters
	subq.w	#4,d3			; must have at least four parameters
	bmi.s	beo_exbp		; ...oops
	beq.s	beo_doit		; exactly, set outline

	subq.w	#2,d3			; up to three more
	bmi.s	beo_smov		; only one, it's move flag

	move.l	0(a6,a2.l),d1		; two or three include shadow
	addq.l	#4,a2			; may be a flag afterwards
	tst.w	d3			; is there?
	beq.s	beo_doit		; no

beo_smov
	move.w	0(a6,a2.l),d2		; set move flag

beo_doit
	moveq	#-1,d3			; sometime
	moveq	#iop.outl,d0		; set outline to definition on RIstk
	trap	#4			; that's A6-relative
	trap	#3

beo_exit
	tst.l	d0
rts
	rts

beo_exbp
	moveq	#err.ipar,d0
	rts

	end
