* S*Basic function: Suspend job
* pjwitte 2oo2 May 5th 2002.. 2019+
*
* V0.02, pjw, April 25th 2019, SMSQ nomenclature
*
* Now part of SMSQ/E (V3.34+)
*
* Compatible: All


        section code

        xdef susjb

        xref getpars

        include dev8_keys_qdos_sms
        include dev8_keys_err

*
susjb
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Suspend a job
*
* SUSJB [jobid,] timeout%
*
* If jobid is not present or is set to -1, the current job is suspended
* timeout% = 0..32k frames, or -1 => forever
*
        moveq   #6,d0           get some longs
        bsr     getpars
        bne.s   exit

        moveq   #-1,d1          default = myself

        subq.w  #2,d3           how many pars?

        bgt.s   err_bp           too many
        bne.s   onepar

        move.l  0(a6,a1.l),d1   d1 = job id
        addq.l  #4,a1

onepar
        move.l  0(a6,a1.l),d3   d3.w = timeout

        moveq   #sms.ssjb,d0
        suba.l  a1,a1           no flag byte
        trap    #do.smsq
        tst.l   d0

exit
        rts

err_bp
        moveq   #err.ipar,d0
        rts

*
        end
