* SBAS_PROCS_SCR - SBASIC SCR Information  V2.00    1994  Tony Tebby
*
* V0.01, pjw, 2019 Aug 02, packaged for compatability toolkit
* V0.02, pjw, 2021 Oct 29, re-writen and expanded, using QL defaults for
*             non-PE compliant systems - ie if platform implementers and
*             Qdos developers dont set the slnk variables in the con driver
*             definition block, the SCR_xxx commands will return incorrect
*             results!
* V0.02, pjw, 2022 May 28, DISP_TYPE moved to separate file for sQLux
*
* Compatible with QDOS and Minerva. SMSQ/E has these built in!
*

        section code

        xdef     scr_base
        xdef     scr_llen
        xdef     scr_xlim
        xdef     scr_ylim

        xref     chan_d6
        xref     l2frtrd6

        include dev8_keys_con
        include dev8_keys_qdos_io
        include dev8_keys_qdos_sms
        include dev8_keys_sys

;+++
; SCR_BASE
;---
scr_base
        moveq    #pt_sbase/2,d7
        moveq    #-1,d5

        move.l   #$20000,d4             QL screen base

        bra.s    scr_do
;+++
; SCR_LLEN
;---
scr_llen
        moveq    #pt_bytel/2-1,d7

        move.w   #$80,d4                QL llen

        bra.s    scr_dow
;+++
; SCR_XLIM
;---
scr_xlim
        moveq    #pt_ssizx/2-1,d7

        move.w   #$200,d4               QL xlim

        bra.s    scr_dow
;+++
; SCR_YLIM
;---
scr_ylim
        moveq    #pt_ssizy/2-1,d7

        move.w   #$100,d4               QL ylim

scr_dow
        moveq    #0,d5
        not.w    d5                     word mask
scr_do
        add.w    d7,d7                  true index

        moveq    #1,d6
        bsr      chan_d6
        bne.s    scr_rts

        moveq    #0,d1
        moveq    #0,d2
        moveq    #-1,d3
        moveq    #iop.slnk,d0           find linkage
        trap     #3
        tst.l    d0
        beq.s    pi_ok

        move.l d4,d6                    use QL defaults
        bra.s ret

pi_ok
        move.l (a1,d7.w),d6             value to return

ret
        and.l d5,d6
        bra l2frtrd6

scr_rts
        rts

*
        end
